Welcome

Welcome to the SEL Device Driver Manual

(925) 262-4222

http://www.relabsoft.com

info@relabsoft.com


Trademarks

ClearControlsâ is a registered mark of ReLab Software (2006 ClearControls®. All rights reserved.).

Microsoft, Intellution, Wonderware, RSView, Subnet, CoDeSys, Survalent, Kepware, Matrikon, Barrington, LanStar, MicroStar are trademarks of their respective corporations.

(925) 262-4222

http://www.relabsoft.com

info@relabsoft.com


Preface

This manual will assist you in configuring proper communications between Schweitzer Engineering Laboratories’ (SEL) Communication Processor and Relay/Meter devices and ReLab OPC Server.


Communication Processor SEL-2030/2032

Before configuring the SEL OPC I/O server, the SEL Communications Processor should be configured to collect, consolidate, and output the desired data. The SEL Communications Processor should also be configured to enable automatic sequential events recorder (SER) collection on ports attached to SEL relays that support the SEL binary unsolicited SOE messages. The SEL relays should also have the Send Automatic Messages (AUTO = Y) and Fast Operate (FASTOP = Y) settings enabled in the relay port (SET P) settings.

The collection of data from IEDs into the SEL Communications Processor is accomplished via the Automatic Message settings (SET A). Automatic sequential events recorder collection is also enabled via the Automatic Message settings.

Consolidation of data collected from various ports of the SEL Communications Processor is accomplished via the Math/Data Movement settings (SET M). For a detailed explanation of Automatic Message settings and Math/Data Movement settings, refer to Chapter 7 (Settings) of the SEL-2030/2032 instruction manual or Chapter 6 (Settings) of the SEL-2020 instruction manual.

The output of collected/consolidated data from a master port of the SEL Communications Processor is accomplished via an unsolicited write (\W) message located in the master port Automatic Message settings. The \W message is a message string designed to move data from a source address in the SEL Communications Processor, out a master port, and to a destination address (another SEL Communications Processor or a server). For a detailed explanation of the \W message, refer to Chapter 5 (Message Strings) of the SEL-2030/2032 instruction manual or Chapter 8 (Message Strings) of the SEL-2020 instruction manual.

Contents of this section

§ Configuring SEL Communications Processor for ReLab OPC Server

§ Loading SEL OPC Driver

§ Configuring OPC Driver for Serial Communication

§ Configuring OPC Driver for TCIP/IP Communication

§ Mapping SEL addresses to ReLab OPC Server


Configuring SEL Communications Processor for CVOPC

Configuring SEL Communications Processor for RLOPC

The following illustrates the required configuration settings of the SEL Communications Processor for use with OPC SEL device driver.

Mathematical/Move Equation Settings for Port 3

After the SEL Communications Processor has been configured to collect the desired data from the attached IED, the data should be concentrated into the user region (using SET M) of the port used to communicate with the IED.

Click to view an illustration of the data selected from the 20METER and 20TARGET responses, which were obtained from a SEL relay connected to Port 3 of the SEL Communications Processor.

Port Communications Settings - Server

Use the SET P command to configure the SEL Communications Processor port to communicate with the server at the desired baud rate.

Click to view an illustration of the SEL Communications Processor port settings for the master port (15) attached to the server.

Automatic Message Settings for Port 15

After the data has been collected into the SEL Communications Processor and moved into the user region, it is available to be sent out the master port via a \W message. Apply the \W message string in the Automatic Message settings (SET A) of the port attached to the server. In the following example, the 13 registers consolidated into the user region previously using the SET M command are sent out Port 15 in a data stream via the \W message. In the example illustrated here, the data concentrated into the user region of Port 3 is sent to the server via the following \W message:

The SEL Communications Processor has a limit of 12 messages per port. If there are more IEDs attached than available messages, multiple \W messages may be cascaded into one message as follows (SEL-2030/2032 only):

\W;3:USER:0000h;13,3:USER:0000h/\W;4:USER:0000h;13,4:USER:0000h/


Loading ClearView's OPC SEL Device Driver

Loading OPC SEL Device Driver

After configuring the SEL Communications Processor, configure the settings on the ReLab OPC Server as described in these steps:

1. On the Windows taskbar, click the Start command.

2. Select Programs, ReLab Software, and then ReLab OPC Product Suite.

3. Click ReLab OPC Console.

The ReLab OPC Console appears.

4. On the Configure menu of the ReLab OPC Console, click Load Driver.

5. In the Device Driver to Load dialog box, from the list of drivers, select OPC SEL Device Driver.

6. In the Driver Name field, type a descriptive name.

7. Click OK.

The SEL Driver Configuration dialog box appears.


Configuring OPC Driver for Serial Communication

The ReLab OPC Server can communicate to the SEL Communications Processor via serial or Ethernet connections. The following steps detail configuration for serial communications.

1. In the SEL Driver Configuration dialog box, verify that the SEL Device tab is displayed.

2. In the SEL Device field, select Communications Processor.

3. In the Level 1 Password field, type a password for the SEL Communications Processor.

4. In the Connection field, select Serial.

5. In the Send delay field, type the desired number of milliseconds, or accept the default value of zero. Thirty or more milliseconds is recommended for all SEL devices. This insures time delays between message sends (writes) to the SEL devices.

6. In the Synchronization field, select the method of synchronization.

NOTE If you have an IRIG clock connected to the Communications Processor, select No synchronization or Adjust PC data and time.

If the ReLab OPC Server is installed on a SEL-3351, select No synchronization.

7. Click the Processor tab.

8. In the Poll timeout field, type a value larger than the total unsolicited write message (\W) time.

9. Click OK.

The ReLab Comm Port Configuration dialog box appears.

10. In the General tab of the ReLab Comm Port Configuration dialog box, set the following fields to communicate with the SEL Communications Processor:

§ Port

§ Baud Rate should be set to match the setting defined in the SEL Communications Processor.

§ DTR (set to Enable if using SEL 2800 series fiber transceivers)

§ RTS (set to Enable if using SEL 2800 series fiber transceivers)

11. Click OK.

Continue by Mapping SEL addresses to ReLab’s OPC Server.


Configuring OPC Driver for TCP/IP Communication

For Ethernet connections, the ReLab OPC Server requires the use of a SEL-2890 Ethernet transceiver. The SEL-2890 should be configured prior to configuring the OPC Server.

SEL-2890 Ethernet Configuration

The SEL-2890 provides an Ethernet gateway to IEDs that are based on EIA-232 serial communications. The SEL-2890 encapsulates serial data into the Ethernet stack.

Click to view an illustration of the settings required to configure the SEL-2890 to pass data to the ReLab OPC Server.

NOTE The SEL-2890 requires +5 Vdc power on pin 1 of the DB9 connector. The SEL Communications Processor can provide this power via internal jumper settings. For locations and jumper numbers, refer to section 2 (installation) of the SEL-2030/2032 instruction manual or section 3 (Installation) of the SEL-2020 instruction manual. The SEL-2030/2032 can supply this power only on ports 3, 4, 11, 12, 14, and 16.

SEL TCP/IP Device Driver Configuration

1. In the SEL Driver Configuration dialog box, verify that the SEL Device tab is displayed.

2. In the SEL Device field, select Communications Processor.

3. In the Level 1 Password field, type a password for the SEL Communications Processor.

4. In the Connection field, select TCP/IP.

5. In the Send delay field, type the desired number of milliseconds, or accept the default value of zero, to insure time delays between message sends (writes) to SEL devices.

6. In the Synchronization field, select the method of synchronization.

NOTE If you have an IRIG clock connected to the Communications Processor, select No synchronization or Adjust PC data and time.

If the ReLab OPC Server is installed on a SEL-3351, select No synchronization.

7. Click the Processor tab of the SEL Driver Configuration dialog box.

8. In the Poll timeout field, type a value larger than the total unsolicited write message (\W) time.

9. Click OK.

The ReLab TCP/IP Configuration dialog box appears.

10. In the ReLab TCP/IP Configuration dialog box, set the following fields to communicate with the SEL Communications Processor:

§ In the IP Address field, type the IP Address of the SEL-2890.

§ In the Port field, type the Port number (PORT setting in SEL-2890) to be used for Telnet connections to the SEL Communications Processor.

11. Click OK.

You are done configuring the OPC SEL device driver for communicating to the SEL Communications Processor over TCP/IP.


Mapping SEL Addresses to ClearView's OPC Server

Mapping SEL Addresses to ReLab OPC Server

After adding and configuring the OPC SEL Device Driver for the SEL Communications Processor, map registers to the ReLab OPC Server by following the steps in this section.

1. Create an OPC Group as described in the RLOPC User's Manual.

2. Type a descriptive name for the Group you created, such as “SEL-2032.”

3. Right-click on the data type you want to map from into the Group, then click Map Register(s) to…

Click to view a list of Driver Data Types.

NOTE Selecting the Auto Map or Map All To options will map all available registers from all the Communications Processor port’s User region registers to the OPC Service Address Space.

The Map Register dialog box appears.

4. Using the horizontal and vertical scroll bars, find the range of registers you want to map to the Group.

TIP Use the Shift and Control keys to assist in selecting multiple registers.

5. Select the desired registers, then click Map.

The registers are automatically mapped to the Group shown in the OPC Server Address Space of the ReLab OPC Console.

6. On the ReLab OPC Console, click the Dashboard tab to see the values in the registers.


SEL Relay/Meter

SEL Relay/Meter Configuration

Before configuring the OPC SEL Device Driver, the SEL relay/meter should be configured to send auto messages and to allow Fast Operates.

Contents of this section

  • Configuring Relay/Meter for Serial Communication

  • Loading OPC SEL Device Driver

  • Configuring the SEL TCP/IP Relay/Meter Device Driver

  • Mapping SEL Addresses to ReLab OPC Server

  • Relay/Meter Flex Parsing Configuration

  • Testing Flex Parsing

  • Creating User Configurable Tags


Configuring Relay/Meter for Serial Communication

Communications Port Settings

PROTO = SEL

SPEED = 19200    BITS  =
8        PARITY= N
       STOP  = 1

T_OUT = 0 AUTO = Y RTSCTS= N FASTOP= Y

The SEL driver uses Fast Operate messages to control the Remote Bits and the Breaker Bit(s). To enable this control, set FASTOP = Y.

The SEL driver also parses data from SEL relay unsolicited auto messages. To enable this data collection, set AUTO = Y.


Loading ClearView's OPC SEL Device Driver (Relay/Meter)

Loading OPC SEL Device Driver (Relay/Meter)

After configuring the SEL Communications Processor, configure the settings on the ReLab OPC Server as described in these steps:

1. On the Windows taskbar, click the Start command.

2. Select Programs, ReLab Software, and then ReLab OPC Product Suite.

3. Click ReLab OPC Console.

The ReLab OPC Console appears.

4. On the Configure menu of the ReLab OPC Console, click Load Driver.

5. In the Device Driver to Load dialog box, from the list of drivers, select OPC SEL Device Driver.

6. In the Driver Name field, type a descriptive name.

7. Click OK.

The SEL Driver Configuration dialog box appears.

Configuring Serial Communication to SEL Relay/Meter

The OPC server can communicate to SEL relays/meters via serial or Ethernet connections. The following steps describe the configuration for serial communications.

1. In the SEL Driver Configuration dialog box, verify that the SEL Device tab is displayed.

2. In the SEL Device field, select Relay/Meter.

3. In the Level 1 Password field, type a password for the Relay/Meter.

4. In the Connection field, select Serial.

5. In the Send delay field, type the desired number of milliseconds, or accept the default value of zero. Thirty or more milliseconds is recommended for all SEL devices. This insures time delays between message sends (writes) to the SEL devices.

6. In the Synchronization field, select the method of synchronization.

NOTE If you have an IRIG clock connected to the Communications Processor, select No synchronization or Adjust PC data and time.

7. Click the Relay tab of the SEL Driver Configuration dialog box.

8. Type the desired data update rates for the following fields:

§ Fast meter poll interval

§ Demand Fast Meter poll interval

§ Peak Demand Fast meter poll interval

§ Check empty buffer interval (should be set to 170 for SEL-2410 devices)

9. The SEL OPC Server provides the ability to configure the driver offline or to use relay static configuration.

§ To enable an offline configuration, click to select the Offline configuration box, and in the Path to configuration file field, select an offline file having an .AC extension.

§ Follow these steps to enable relay static configuration:

o        Configure the SEL Meter/Relay.

o        Verify that the SEL OPC Server communicates with the SEL device.

o        Save the current configuration.

o        In the Relay tab of the SEL Driver configuration dialog box, click to select the Relay static configuration box, then click OK.

o        Save the configuration and reload the driver.

§ Follow these steps to reconfigure the relay static configuration:

o        Click to clear the Relay static configuration box, then click OK.

o        Connect to the SEL device and verify the communications.

o        In the Relay tab of the SEL Driver configuration dialog box, click to select the Relay static configuration box, then click OK.

o        Save the configuration and reload the driver.

10. Click OK.

The ReLab Comm Port Configuration dialog box appears.

11. In the General tab of the ReLab Comm Port Configuration dialog box, select the desired values for the following fields:

§ Port

§ Baud Rate

§ Data Bits

§ Stop Bits

§ Parity

§ DTR (set to Enable if using SEL 2800 series fiber transceivers)

§ RTS (set to Enable if using SEL 2800 series fiber transceivers)

12. Click OK.

Continue by Mapping SEL addresses to ReLab OPC Server.

TCP/IP Relay/Meter Connection Configuration

The OPC server can communicate to SEL relays/meters via serial or Ethernet connections.

For serial relay/meter configuration, refer to Configuring Serial Communication to SEL Relay/Meter.

For Ethernet connections, the SEL OPC I/O server requires the use of a SEL-2890 Ethernet transceiver. These steps describe the configuration for Ethernet communications.

SEL-2890 Configuration

The SEL-2890 provides an Ethernet gateway to IEDs that are based on EIA-232 serial communications. The SEL-2890 encapsulates serial data into the Ethernet stack.

Click to view an illustration of the settings required to configure the SEL-2890 to pass data to the ReLab OPC Server.

NOTE The SEL-2890 requires +5 Vdc power on pin 1 of the DB9 connector. The SEL relay/meter can provide this power via internal jumper settings. For locations and jumper numbers, refer to the installation section of the relay/meter instruction manual.


Configuring the SEL TCP/IP Relay/Meter Device Driver

Follow these steps to configure the OPC SEL device driver for communicating to a SEL Relay/Meter over TCP/IP.

1. Load OPC SEL Device Driver.

2. On the SEL Driver Configuration dialog box, click the SEL Device tab.

3. In the SEL Device tab, in the SEL Device field, select Relay/Meter.

4. In the Level 1 Password field, type a password for the Relay/Meter.

5. In the Connection field, select TCP/IP.

6. In the Send delay field, type the desired number of milliseconds, or accept the default value of zero. Thirty or more milliseconds is recommended for all SEL devices. This insures time delays between message sends (writes) to the SEL devices.

7. In the Synchronization field, select the method you want.

NOTE If you have an IRIG clock connected to the Relay/Meter, select No synchronization or Adjust PC data and time.

8. Click the Relay tab.

9. On the Relay tab, set the desired data update rates for the following fields:

§ Fast Meter poll interval

§ Demand Fast Meter poll interval

§ Peak Demand Fast meter poll interval

§ Check empty buffer interval (should be set to 170 for SEL-2410 devices)

10. The SEL OPC Server provides the ability to configure the driver off-line or to use relay static configuration.

§ To enable an off-line configuration, click to select the Offline configuration box, and in the Path to configuration file field, select an off-line file having an .AC extension.

§ Follow these steps to enable relay static configuration:

o        Configure the SEL Meter/Relay.

o        Verify that the SEL OPC Server communicates with the SEL device.

o        Save the current configuration.

o        In the Relay tab of the SEL Driver configuration dialog box, click to select the Relay static configuration box, then click OK.

o        Save the configuration and reload the driver.

§ Follow these steps to enable relay static configuration:

o        Click to clear the Relay static configuration box, then click OK.

o        Connect to the SEL device and verify the communications.

o        In the Relay tab of the SEL Driver configuration dialog box, click to select the Relay static configuration box, then click OK.

o        Save the configuration and reload the driver.

11. Click OK.

The ReLab TCP/IP Configuration dialog box appears.

12. In the ReLab TCP/IP Configuration dialog box, in the IP Address field, type the address for the Relay/Meter.

13. In the Port field, type the port number used for Telnet connections to the Relay/Meter.

14. Click OK.

You are done configuring the OPC SEL device driver for communicating to a SEL Relay/Meter over TCP/IP.


Mapping SEL Addresses to ClearView's OPC Server (Relay/Meter)

Mapping SEL Addresses to ReLab OPC Server (Relay/Meter)

After adding and configuring the OPC SEL Device Driver for the SEL Relay/Meter, map registers to the ReLab OPC Server by following the steps in this section.

1. Right-click in the OPC Server Address Space of the ReLab OPC Console, then click to select Create Group from the popup menu.

2. Type a descriptive name for the Group you created.

3. In the Loaded Device Drivers window of the ReLab OPC Console:

§ Expand the device tree and right-click on the data type you want to map into the Group.

Click to view a list of Driver Data Types.

§ Select Map All to…

4. Select the Group to map the registers to, then click OK.

The registers are automatically mapped to the Group shown in the OPC Server Address Space.

5. Click the Dashboard tab to see the values in the registers.


Relay/Meter Flex Parsing Configuration

This method parses received characters according to a user-defined Decode string. The Decode string identifies data types and search strings expected in the received characters. Text strings that match the Decode string are stored into the OPC Server tags.

OPC Server Configuration

  1. On the ReLab OPC Console, click the Configuration tab.

  2. In the Loaded Device Drivers window, right-click on one of the Relay/Meter devices listed.

  3. Select Properties.

The SEL Driver Configuration dialog box appears.

  4. In the SEL Driver Configuration dialog box, click the Flex Parsing tab.

  5. In the Groups list, select a FLEX(n) message.

  6. In the Decode string field, type a decode string.

  7. In the Message field, type a message to be sent to the relay.

  8. If the message is to be sent only when certain conditions are met:

  • Check to select the when value of expression box.

  • In the when expression field, type an expression that must evaluate to true for the message to be sent.

Otherwise:

  • Check to select the every box.

  • In the when expression field, type an expression that must evaluate to true for the message to be sent.

OR

  • In the seconds field, type the number of seconds for a periodically sent message.

  9. Click OK to close the SEL Driver Configuration dialog box.

The Communication Configuration screen appears.

  10. Click OK to return to the ReLab OPC Console.


Testing Flex Parsing

Follow these steps to verify your Flex Parsing Decode String.

  1. On the Flex Parsing tab of the SEL Driver Configuration screen, click Flex Parsing Test.

  2. In the Flex Parsing dialog box, in the Syntax field, type your Decode String.

  3. Click Parse to test the Decode String.

  4. Click Submit to send the code to the Relay/Meter.


Creating User Configurable Tags

This method creates three user configurable tags.

The user configurable tags, specified using the User configurable tags tab of the SEL Driver Configuration dialog box, are Booleans with write property only.

The user configurable "hints" are located under the ASCII_Command_W Boolean branch of the driver tree.


Flex Parsing Technique

This technique parses received characters according to a user-defined Decode Equation. The Decode Equation identifies data types and search strings expected in the received characters. Text strings that match the Decode Equation are stored into the OPC tag.

Contents of this section

  • Decode Equations

  • Decode Elements

  • Search Strings

  • Tag Storage and Parsing Rules

  • Parsing Precedence

  • Flex Parse Settings

  • Parsing Precedence Examples

  • Flex Parsing Example


Decode Equations

A Decode Equation consists of one or more Decode Expressions as shown below

DEQ = DEXP1, DEXP2,…DEXPn,

Use braces { } to enclose a group of expressions together. This is especially useful when parsing tabular data. The following string is an example of a Decode Equation:

4{(I,S5,I,F)&’\00D’}

The parser expects four rows of data with each row containing an integer, string of 5 characters, an integer, and a floating-point value. At the end of each row is a carriage return.

A Decode Expression consists of one or more Decode Elements or a Search String as shown below.

DExp = DElem

D Exp = (DElem1, DElem2, …, DElemn)

D Exp = Search String

Use parentheses ( ) to enclose a logical group of Decode Elements, and commas to separate the Decode Elements within a logical group. The following string shows an example of a Decode Expression with three Decode Elements.

I, 3F, S20

It specifies one integer, an array of three floating-point numbers, and a string of 20 characters.


Decode Elements

A Decode Element consists of a Data Type (Type) and optional parameters as shown below. The Data Type must be entered in uppercase in the decode settings.

DElem = [r]Type[n]

These optional parameters are shown below in brackets but the brackets are not actually entered. The Data Type and optional parameters are defined in the Decode Element Definitions table.

An example of a Decode Element is: 2F5. This example shows an array of two floating-point numbers, each with a maximum of 5 ASCII characters.

Decode Elements that are not parsed correctly are given an OPC Bad quality.

Decode Element Definitions

Element | Definition
r | Optional number of times to repeat the data type in the expanded Decode Equation. Range is 1–2048. Repeat count data items are stored as an array.
Type | Type Data Type. The parser ignores all leading white space (space or tab characters) for all data types except C. See the Data Type Characteristics table for specific data types and definitions.
n | Optional maximum expected size of the ASCII string for the data type. Range is 1–32767. If n is not specified, the value of n is based on the data type specified. See the Data Type Characteristics table for the default length of n.

Data Type Characteristics

Element | Definition | Default Length (if not specified)
I | Integer (0–9 and leading + or –) | 5 valid characters plus sign
F | Floating Point (0–9, + or –, and scientific notation) | 10 valid characters
S | ASCII String (all ASCII characters excluding leading white space) | 1 character
H | ASCII Hexadecimal Number (0–9, A–F, a–f) | 4 valid characters

Once a valid character is found, all valid characters are read and stored until the specified length of characters is read or an invalid character is found.


Search Strings

A Search String in the Decode Expression instructs the parser to search the incoming message for an exact match or until the message acquisition times out. Use any keyboard character in a string. A Search String may be specified with either a preceding ampersand (&) or a comma as shown below.

SExp = ‘str’

SExp = & ‘str’

SExp = , ‘str’

A preceding ampersand causes the parser to search the incoming string for an exact match to the Search String. If the Search String is found, the previous Decode Expression is evaluated. If the Decode Expression is successfully parsed before the Search String is found, the Search String is treated as a Search String with a preceding comma. When using the ampersand, the Search String has precedence over the preceding Decode Expressions.

A preceding comma causes the parser to evaluate all expressions in the specified order. If an expression before the search string fails, and then the Search String is found, the parser continues parsing after finding the Search String.

The Search String allows characters in hexadecimal format using \0xx (where xx is a hexadecimal number represented by uppercase ASCII characters). Null characters (\000) and single quotes are not allowed within Search Strings. The following string is an example of a Search String.

‘Text’, I, F& ‘str’

The parser searches for the ‘Text’ string, then it parses the next integer and floating-point value. While evaluating the floating-point value, the parser is also searching for the ‘str’ Search String. If ‘str’ is found before the floating-point, the floating-point parse failed and the OPC Quality flag is set to Bad.


Tag Storage and Parsing Rules

After successful setting creation, the tag storage is reserved. After receipt and parsing of the first response, the tags are valid regardless of the success or failure of the data parsing. This allows you to view the tag quality and aids in troubleshooting the Decode Equation.

Space is reserved for each data type, and the index into the data type array is also reserved. For example using a decode expression of I,F,F,S,H will reserve five indices in each data type. The index for the Integer type is 0000 and that index is reserved in all data types. The floating points reserve indices 0001 and 0002. The string reserves index 0003, and the hexadecimal is index 0004.

Consider parsing the string:

123 2.3 4.5 Time 1FBC

The tag storage and parse results are given below. Notice that the first item is the integer tag and it reserves the index 0000 for all subsequent data types. For consistency, index 0000 is shown for the other data types even though it can only be a good value in the type ‘short’. The data type ‘Word’ is used for Hexadecimal values, and the value is at index 0004.

FPV(0000), short, Good, 123

FPV(0001), short, Bad, 0

FPV(0002), short, Bad, 0

FPV(0003), short, Bad, 0

FPV(0004), short, Bad, 0

FPV(0000), word, Bad, 0

FPV(0001), word, Bad, 0

FPV(0002), word, Bad, 0

FPV(0003), word, Bad, 0

FPV(0004), word, Good, 1FBC

FPV(0000), float, Bad, 0

FPV(0001), float, Good, 2.3

FPV(0002), float, Good, 4.5

FPV(0003), float, Bad, 0

FPV(0004), float, Bad, 0

FPV(0000), str, Bad, (null)

FPV(0001), str, Bad, (null)

FPV(0002), str, Bad, (null)

FPV(0003), str, Good, Time

FPV(0004), str, Bad, (null)

An element is parsed successfully if the first character evaluated is within the ranges specified in Table 2 for each data type. Once a valid character is found, all valid characters are read and stored until the maximum number of characters is read or an invalid character is found.

If an invalid character is read before any valid characters, then the parse rule fails and the data element OPC Quality flag is set to Bad.

If an invalid character is found after at least one valid character, the current Decode Element is valid and evaluation of the next element starts.

If all the Decode Elements within a Decode Expression fail, or the message collection times-out, then all OPC Quality flags for the remaining data elements referenced in the Decode Equation are set to Bad.


Parsing Precedence

Parsing is evaluated from left to right according to the Decode Equation. However, special rules apply to Search Strings using a preceding ampersand. This type of Search String is referred to as an ampersand Search String in the text below.

If a Search String is the first expression in the Decode Equation, then the parser searches for the Search String in the message. Once the Search String is found, evaluation of the Decode Equation proceeds. The ampersand Search String has the highest precedence. If a Decode Equation contains a Search String, and the Search String is found before the completion of the previous Decode Expression, the Decode Expression has failed and all Quality flags for the remaining elements in the Decode Expression are set to Bad.

If the incoming string contains data that is both valid for the specified data type, and matches the ampersand Search String, the Search String has precedence. Therefore, the parse of the data type fails. If the incoming data only contains the Search String, then the previous Decode Expression fails.

The ampersand Search String is evaluated with the preceding Decode Expression. A Search String with a preceding comma is evaluated in the order it appears in the Decode Expression.


Flex Parse Settings

For each FLEX parse, there are three main settings.

Decode String – The decode setting as described above.

Message – The ASCII message sent from the computer to the attached relay/meter. The response from the relay/meter is parsed according to the rules in the Decode String.

Issue Condition – When to send the message to the relay/meter. This can be either a periodic condition (such as every 3.5 seconds), or based on an OPC tag changing state.


Parsing Precedence Examples

I, F, H& ‘str’ The parser watches for ‘str’ while evaluating for the H element. If ‘str’ is found before the H element, then the OPC Quality flag is Bad.

I, (F, H)& ‘str’ The parser watches for ‘str’ while evaluating for both the F and H elements. If ‘str’ is found while evaluating F, both F and H OPC Quality flags are Bad.

2{I, (F, H)}& ‘str’ In this case, because the ‘str’ is outside the brace, the ‘str’ is only searched for on the very last element of the array. To evaluate ‘str’ for each row of the array, move ‘str’ inside the brace.

I, H, ‘str’, F The parser evaluates the incoming data for Integer and Hex and then parses the data until ‘str’ is found. After ‘str’ is found, the parser evaluates the next floating point. If H is not found and ‘str’ is found, processing continues for F.


Flex Parsing Example

Parse the maximum and minimum values from an SEL-351R min/max meter report.

Enter the following parser settings.

DECODE = “ ‘Min’, ‘\00D’, 11{S6, (F, 5I, F, F, 5I, F)& ‘\00D’}”

MESSAGE = “MET M \n”

Send Message every = 600 seconds

These settings cause the parser to request a min/max meter report from the SEL-351R every 10 minutes and parse the response according to the decode string. Click to view an example SEL-351R Min/Max Meter Report.

In SEL-351R Min/Max Report example, the parser inspects 11 rows of data after finding the ‘Min’ string and a carriage return. If a row contains min and max data, the database stores the following data for the Max string and repeats the process for the Min string:

First Label IA(A)

Max Value as a Floating-Point Value 200.0

Date and Time as Integers (up to the seconds field) 03 28 01 10 38

Seconds as a Floating-Point Value 56.774

If the row contains the “RESET” string, the decode elements are not evaluated and the OPC Quality flags are set to Bad.


Sequence-of-Events Recorder (SER)

After loading/configuring the OPC SEL device driver and the Communications Processor and/or relay settings, the ReLab OPC Server can be configured for SER data collection. The following steps detail the server configuration process.

1. Right click on one of the SEL devices listed in the Loaded Device Drivers window.

2. Click Properties to open the SEL Driver Configuration dialog box for the device.

3. On the SEL Driver Configuration dialog box, click the History tab.

4. In the History tab:

§ Click the Enable history box.

§ In the Path to History file(s) field, type a path to the history file location or use the file folder icon to navigate to the desired location.

§ Under Create new history file, select the desired option by clicking the corresponding radio button.

§ In the Maximum number of history files field, type the maximum number of files to save.

§ Click OK to save your changes.

Either the ReLab Comm Port Configuration or the ReLab TCP/IP Configuration dialog box appears.

5. In the Comm Port Configuration or TCP/IP Configuration dialog box, click OK to return to the ReLab OPC Console.


Driver Data Types

Driver Data Types | Description
Boolean | Single bit (single bit of a 16 bit register)
Byte | Unsigned 8 bit value
Char | Signed 8 bit value
Word | Unsigned 16 bit value
Short | Signed 16 bit value
DWord | Unsigned 32 bit value
Long | Signed 32 bit value
Int | Signed 16 bit
Date | Unsigned 32 bit value
Float | 32 bit IEEE floating point
String | Null terminated character array


Mathematical/Move Equation Settings for Port 3 illustration

1 000h = 03:METER:IA

2 001h = 03:METER:IB

3 002h = 03:METER:IC

4 003h = 03:METER:IN

5 004h = 03:METER:VAB(V)/100

6 005h = 03:METER:VBC(V)/100

7 006h = 03:METER:VCA(V)/100

8 007h,F = 03:METER:P(MW)

9 009h,F = 03:METER:Q(MVAR)

10 00Bh:0;B = 3:TARGET:LED1

11 00Bh:1;B = 3:TARGET:LED2

12 00Bh:2;B = 3:TARGET:LED3

13 00Bh:3;B = 3:TARGET:LED4

14 00Bh:4;B = 3:TARGET:LED5

15 00Bh:5;B = 3:TARGET:LED6

16 00Bh:6;B = 3:TARGET:LED7

17 00Bh:7;B = 3:TARGET:LED8

18 00Bh:8;B = 3:TARGET:LED9

19 00Bh:9;B = 3:TARGET:LED10

20 00Bh:10;B = 3:TARGET:LT1

21 00Bh:11;B = 3:TARGET:LT2

22 00Bh:12;B = 3:TARGET:LT3

23 00Bh:13;B = 3:TARGET:LT4

24 00Bh:14;B = 3:TARGET:LT5

25 00Bh:15;B;PUSHBUTTON_LEDS = 3:TARGET:LT6

26 00Ch,C;;TARGET_LEDS = 03:TARGET:0005h;2


Port Communications Settings for Server Communications Port illustration

PORT:15

DEVICE = M

PROTOCOL= S

FAST_OP = Y

PORTID ="HMI"

MODEM = N

BAUD = 38400

DATABIT = 8 STOPBIT = 1 PARITY = N

RTS_CTS = N XON_XOFF= Y

TIMEOUT = OFF ECHO = Y

AUTO_HELP= N

TERTIME1= 1

TERSTRING="\004"

TERTIME2= OFF


SEL-351R Min/Max Meter Report

==>>MET M <Enter>

RECLOSER R1 Date: 03/28/01 Time: 10:39:02.389

FEEDER XYZ

Max Date Time Min Date Time

IA(A) 200.0 03/28/01 10:38:56.774 198.0 03/28/01 10:38:57.291

IB(A) 202.1 03/28/01 10:38:56.774 199.0 03/28/01 10:38:58.069

IC(A) 202.2 03/28/01 10:38:57.091 197.0 03/28/01 10:38:56.774

IN(A) RESET RESET

IG(A) RESET RESET

VA(kV) RESET RESET

VB(kV) RESET RESET

VC(kV) RESET RESET

VS(kV) RESET RESET

MW3P RESET RESET

MVAR3P RESET RESET

LAST RESET 03/28/01 10:38:56.773


SEL-2890 Ethernet Configuration settings

PORT = 23

TUNNEL = N

UDDELAY = 2

MTDELAY = 0.8

WEB = SEL

DHCP = N

DNS_IP = 192.168.0.1

DOMAIN =

HOST_NAME =

EMAIL = N

ROUTE = N

SPEED = 19200

STOP = 1

PARITY = NONE

FLOW = NONE

RTS_LOW = N

IP = 192.168.1.100

SUBNET_MASK = 255.255.255.0

GATEWAY = 192.168.1.1

MAC = (not a setting, use factory default)